

__s__	equ	0
INCLUDE	ASSM.ASI

DEBUG	equ	0
SOFTLD	equ	0

kbd_flags	equ	17h
tsr_id		equ	0CEA5h


_DATA	segment word public 'DATA'
_DATA	ends
_BSS	segment word public 'BSS'
_BSS	ends
DGROUP	group	_DATA, _BSS


_TSR	segment byte public 'CODE'
	assume	cs:_TSR, ds:_TSR


origin:
	; TSR interface:
	;   AX - TSR ID
	;   BH - function
	;   BH=0	Get installed CYR version / segment (ES:BX)
	;   BH=1	Get XMS handle in BX
	;   BH=2	Set RUS kbd mode
	;   BH=3	Set LAT kbd mode
	;   BH=4	Set CYR screen fonts
	;   BH=5	Set IBM screen fonts
	;   BH=6	Turn translation on
	;   BH=7	Turn translation off
	;   BH=8	Set RUS/LAT hotkey combinations (CL, CH)
	;   BH=9	Set font switch hotkey combinations (CL, CH)
int_2F	proc	far
	cmp	ax, tsr_id
	je	$_1
	db	0EAh		; jmp	far ptr 0
old_2F	dd	0

$_1:	cmp	bh, 8
	jae	$_9
	cmp	bh, 4
	jae	$_5
	cmp	bh, 2
	jae	$_3
	cmp	bh, 0
	jne	$_2
	les	bx, cs:dword ptr versptr	; Fun 0
	iret
$_2:	mov	bx, cs:word ptr handle		; Fun 1
	iret
$_3:	cmp	bh, 2
	jne	$_4
	or	cs:byte ptr flags, 4		; Fun 2
	iret
$_4:	and	cs:byte ptr flags, 0FBh		; Fun 3
	iret
$_5:	cmp	bh, 6
	jae	$_7
	cmp	bh, 4
	jne	$_6
	or	cs:byte ptr flags, 8		; Fun 4
	call	setFont
	iret
$_6:	and	cs:byte ptr flags, 0F7h		; Fun 5
	call	setFont
	iret
$_7:	cmp	bh, 6
	jne	$_8
	or	cs:byte ptr flags, 10h		; Fun 6
	iret
$_8:	and	cs:byte ptr flags, 0EFh		; Fun 7
$_9:	cmp	bh, 10
	jae	$_11
	cmp	bh, 8
	jne	$_10
	mov	cs:word ptr keysw, cx		; Fun 8
	iret
$_10:	mov	cs:word ptr fontsw, cx		; Fun 9
$_11:	iret
int_2F	endp



int_9	proc	far
	push	ax
	push	bx
	push	di
	push	es
	push	ds

	cli
	push	cs
	pop	ds
	mov	es, bios
	mov	di, es:[1Ch]	; Get head of kbd buffer, here will be placed a keystroke
	in	al, 60h
	pushf
	db	9Ah		; call	old_9
old_9	dd	0

	test	byte ptr flags, 20h
	jz	$_0
	test	al, 80h
	jnz	$_0
	call	remlbl
$_0:	cmp	al, 0E0h	; Extended AT keyboard escape code
	jne	$_1
	or	byte ptr flags, 1
	jmp	$_r1

$_1:	mov	ah, al		; Now detect "shift" keys
	and	ah, 7Fh
	test	byte ptr flags, 1
	jz	$_1a
	cmp	ah, 036h	; fake RShft - escaped
	je	$_ra
	cmp	ah, 02Ah	; fake LShft - escaped
	je	$_ra

$_1a:	mov	bl, 1
	cmp	ah, 036h	; RShft
	je	$_2
	mov	bl, 2
	cmp	ah, 02Ah	; LShft
	je	$_2
	mov	bl, 8
	cmp	ah, 038h	; Alt
	je	$_2
	mov	bl, 20h
	cmp	ah, 01Dh	; Ctrl
	jne	$_ord
$_2:	test	byte ptr flags, 1
	jz	$_3
	shr	bl, 1
$_3:				; Now code of "shift" key is in BL

	and	byte ptr flags, 0FEh
	test	al, 80h
	jz	$_6
	test	byte ptr flags, 2	; "shift" key released
	jz	$_5		; was other keys pressed or not?
	mov	al, state
	cmp	al, keysw	; test for hot keys combination
	je	$_rl
	cmp	al, byte ptr keysw+1
	je	$_rl
	cmp	al, fontsw
	je	$_fnt
	cmp	al, byte ptr fontsw+1
	jne	$_4
$_fnt:	or	byte ptr flags, 80h	; toggle screen fonts (postponed)
	jmp	short $_4
$_rl:	call	tgglkbd

$_4:	and	byte ptr flags, 0FDh
$_5:	not	bl
	and	state, bl
$_ra:	jmp	$_r
$_6:	test	state, bl	; "shift" key pressed
	jnz	$_r
	or	state, bl	; it is actually pressed! not autorepeat
	or	byte ptr flags, 2
	jmp	short $_r

$_ord:	and	byte ptr flags, 0FDh	; Now prepare for key translation
	mov	bx, es:[1Ch]
	cmp	di, bx		; No keystrokes placed in buffer
	je	$_r
	mov	word ptr es:[bx], 0	; Clear ahead against HyperKey '' bug
	test	byte ptr flags, 4
	jz	$_r		; No translation needed, LAT mode
	test	byte ptr flags, 1
	jnz	$_r		; Ext. AT escape - additional keypad used
	mov	ah, es:kbd_flags
	test	ah, 0Ch		; Alt or Ctrl key - no translation
	jnz	$_r
	cmp	al, 35h
	ja	$_r

	mov	bx, offset table1 - 1
	test	ah, 3
	jz	$_8
	mov	bx, offset table2 - 1
$_8:	xlat
	cmp	al, 0
	je	$_r
	cmp	al, 80h		; Is it a letter?
	jb	$_put
	test	ah, 40h		; Is CapsLock on?
	jz	$_put
	call	caps		; Change letter case
$_put:
	test	flags, 10h
	jz	$_rdy
	cmp	al, ''
	jne	$_10
	mov	al, 'p'
	jmp	short $_rdy
$_10:	cmp	al, ''
	jne	$_rdy
	mov	al, 'H'
$_rdy:	xor	ah, ah
	stosw

$_r:	and	byte ptr flags, 0FEh
	test	byte ptr flags, 80h	; Perform postponed fonts toggle
	jz	$_r1
	call	word ptr tggl_f		; toggle screen fonts (reenterable)

$_r1:	;	Drop sticky shifts after Windows
	mov	al, byte ptr es:kbd_flags
	test	al, 1
	jnz	$_d0
	and	byte ptr state, 0FEh	; Drop RShift
$_d0:	test	al, 2
	jnz	$_d1
	and	byte ptr state, 0FDh	; Drop LShift
$_d1:	test	al, 4
	jnz	$_d2
	and	byte ptr state, 0CFh	; Drop Ctrl
$_d2:	test	al, 8
	jnz	$_d3
	and	byte ptr state, 0F3h	; Drop Alt
$_d3:	pop	ds
	pop	es
	pop	di
	pop	bx
	pop	ax
	iret
int_9	endp



caps	proc	near
	cmp	al, 80h
	jb	$_r
	cmp	al, 90h
	jb	$_1
	cmp	al, 0A0h
	jb	$_0
	cmp	al, 0B0h
	jb	$_1
	cmp	al, 0E0h
	jb	$_r
	cmp	al, 0F0h
	jb	$_0
	cmp	al, 0F1h
	ja	$_r
	xor	al, 71h
$_0:	xor	al, 50h
$_1:	xor	al, 20h
$_r:	ret
caps	endp



remlbl	proc	near
	push	es
	push	di
	push	si
	push	cx
	push	bx
	push	ax

	mov	ax, es:[4Ah]
	shl	ax, 1
	sub	ax, 10
	mov	di, ax
	mov	es, scrseg
	mov	si, offset ruslbl
	push	di
	call	$_sub
	mov	si, offset latlbl
	pop	di
	call	$_sub
	and	byte ptr flags, 0DFh

	pop	ax
	pop	bx
	pop	cx
	pop	si
	pop	di
	pop	es
	ret

$_sub:	mov	cx, 5
	mov	bx, offset savlbl
$_1:	lodsw
	cmp	ax, es:[di]
	mov	ax, es:[di]
	jnz	$_2
	mov	ax, ds:[bx]
$_2:	stosw
	add	bx, 2
	loop	$_1
	ret
remlbl	endp



tgglkbd	proc	near
	xor	byte ptr flags, 4
	call	isgraph
	jc	$_r

	push	es
	push	ds
	push	di
	push	si
	push	cx
	push	ax

	mov	ax, es:[4Ah]
	shl	ax, 1
	sub	ax, 10
	mov	si, ax
	mov	ds, scrseg
	mov	ax, cs
	mov	es, ax
	mov	di, offset savlbl
	mov	cx, 5
	rep	movsw
	mov	ds, ax
	mov	es, scrseg
	mov	di, si
	sub	di, 10
	mov	si, offset latlbl
	test	byte ptr flags, 4
	jz	$_1
	mov	si, offset ruslbl
$_1:	mov	cx, 5
	rep	movsw
	or	byte ptr flags, 20h

	pop	ax
	pop	cx
	pop	si
	pop	di
	pop	ds
	pop	es
$_r:	ret
tgglkbd	endp



retnear	proc	near	; Stub for keyboard driver when it is alone
	and	byte ptr flags, 3Fh	; Remove reentrance flag & tog. s. f.
	ret
retnear	endp



IF	DEBUG
SCREEN	equ	0B000h
hexax	proc	near
	push	ax
	mov	al, ah
	call	hexal
	pop	ax
	call	hexal
	ret
hexax	endp



hexal	proc	near
	push	ax
	push	ax
	shr	al, 4
	add	al, '0'
	cmp	al, '9'
	jle	$_1
	add	al, 'A'-'9'-1
$_1:	call	putch
	pop	ax
	and	al, 0Fh
	add	al, '0'
	cmp	al, '9'
	jle	$_2
	add	al, 'A'-'9'-1
$_2:	call	putch
	pop	ax
	ret
hexal	endp



putch	proc	near
	push	es
	push	bx
	mov	bx, SCREEN
	mov	es, bx
	mov	bx, cs:pos
	mov	es:[bx], al
	inc	cs:pos
	inc	cs:pos
	pop	bx
	pop	es
	ret
pos	dw	160
putch	endp



stat	proc	near
	push	ds
	push	es
	push	ax

	push	cs
	pop	ds
	mov	ax, SCREEN
	mov	es, ax
	mov	al, '-'
	test	state, 1
	jz	$_1
	mov	al, 'S'
$_1:	mov	byte ptr es:[8], al
	mov	al, '-'
	test	state, 2
	jz	$_2
	mov	al, 'S'
$_2:	mov	byte ptr es:[2], al
	mov	al, '-'
	test	state, 4
	jz	$_3
	mov	al, 'A'
$_3:	mov	byte ptr es:[6], al
	mov	al, '-'
	test	state, 8
	jz	$_4
	mov	al, 'A'
$_4:	mov	byte ptr es:[4], al
	mov	al, '-'
	test	state, 10h
	jz	$_5
	mov	al, 'C'
$_5:	mov	byte ptr es:[10], al
	mov	al, '-'
	test	state, 20h
	jz	$_6
	mov	al, 'C'
$_6:	mov	byte ptr es:[0], al

	pop	ax
	pop	es
	pop	ds
	ret
stat	endp
ENDIF



versptr	dw	offset version, 0
version	db	'0.97', 0
bios	dw	40h
scrseg	dw	0B800h
flags	db	8h
	;  1 - Keyboard escape
	;  2 - Pure shifts manip
	;  4 - RUS/LAT mode
	;  8 - Type of screen fonts used (IBM/CYR)
	; 10 - 'H' and 'p' translation
	; 20 - RUS/LAT label active
	; 40 - Previous instance of INT9 is in work (for reenterability)
	; 80 - Need to toggle screen fonts before iret (it's very slow)
state	db	0		; state of all "shift" keys
keysw	db	3, 11h		; LC, RC, LA, RA, LS, RS
fontsw	db	14h, 28h	; LC, RC, LA, RA, LS, RS
tggl_f	dw	offset retnear
ruslbl	dw	04DEh, 4E52H, 4E75H, 4E73H, 04DDH
latlbl	dw	04DEh, 4E4CH, 4E61H, 4E74H, 04DDH
savlbl	dw	0, 0, 0, 0, 0

memblk:		; XMS move memory control block
length	dd  0		; 32-bit number of bytes to transfer
handle	dw  0		; Handle of source block
xOffset	dd  0		; 32-bit offset into source
	dw  0		; Handle of destination block
xDest	dd  0		; far ptr to destination block

table1	db	0, '1234567890-=', 0
	db	0, '㪥', 0
	db	0, '뢠஫`'
	db	0, '\ᬨ'

table2	db	0, '!"/;:,.*()_+', 0
	db	0, '', 0
	db	0, '?'
	db	0, '|'



int_10	proc	far
	test	byte ptr cs:flags, 8
	jz	$_2
	cmp	ah, 0
	jne	$_1
	push	ax
	and	al, 7Fh
	cmp	al, 3
	jbe	$_3
	cmp	al, 7
	je	$_3
	pop	ax
	jmp	short	$_2
$_1:	cmp	ah, 11h
	jne	$_2
	cmp	al, 1
	je	$_4
	cmp	al, 2
	je	$_4
	cmp	al, 4
	je	$_4
	cmp	al, 11h
	je	$_4
	cmp	al, 12h
	je	$_4
	cmp	al, 14h
	je	$_4
	cmp	al, 10h
	jne	$_2
	cmp	bh, 8
	je	$_2
	cmp	bh, 14
	je	$_2
	cmp	bh, 16
	jne	$_4
$_2:	db	0EAh		; jmp	far ptr old_10
old_10	dd	0
$_3:	pop	ax
$_4:	pushf
	call	cs:old_10

	call	setFont

	iret
int_10	endp



toggle	proc	near
	test	byte ptr flags, 40h
	jnz	$_r
	or	byte ptr flags, 40h	; Enter INT9 reentrance flag
	xor	byte ptr flags, 8
	call	setFont
	and	byte ptr flags, 3Fh	; Remove reentrance flag & tog. s. f.
$_r:	ret
toggle	endp



setFont	proc	near
	push	ds
	push	es
	push	di
	push	si
	push	dx
	push	cx
	push	bx
	push	ax

	mov	ds, cs:bios
	mov	bx, word ptr ds:[85h]	; Cell height
	mov	dx, word ptr ds:[4Ah]	; Screen width
	mov	ax, bx
	sub	al, 8
	cmp	al, 8
	ja	$_r
	shl	ax, 1
	add	ax, offset fonttab
	mov	si, ax
	mov	si, cs:[si]
	cmp	si, 0
	je	$_r

	mov	ax, cs
	mov	ds, ax
	mov	es, ax
	cmp	word ptr handle, 0
	je	$_0
	sub	si, offset font8	; if fonts in XMS they start from 0
$_0:	xor	ax, ax
	mov	cx, 2048
	mov	di, offset fontbuf
	rep	stosw
	mov	di, offset fontbuf
	mov	ch, bl
	mov	cl, 0
	cld
	call	$_ld

	test	byte ptr flags, 8
	jz	$_2
	cmp	dx, 80
	jbe	$_1a

$_1c:	call	$_ldb
	cmp	al, 0
	je	$_1b
	add	si, bx
	jmp	short $_1c

$_1a:	call	$_s
$_1b:	call	$_s
$_2:	cmp	dx, 80
	ja	$_3
	call	$_s

$_3:	call	ldfont

$_r:	pop	ax
	pop	bx
	pop	cx
	pop	dx
	pop	si
	pop	di
	pop	es
	pop	ds
$_r1:	ret

$_s:	call	$_ldb
	cmp	al, 0
	je	$_r1
	mul	bl
	mov	di, offset fontbuf
	add	di, ax
	mov	cx, bx
	cld
	call	$_ld
	jmp	short $_s

$_ld:	cmp	word ptr handle, 0
	jnz	$_ld1
	rep	movsb
	ret
$_ld1:	call	downXMS
	ret

$_ldb:	cmp	word ptr handle, 0
	jnz	$_ld2
	lodsb
	ret
$_ld2:	call	getXMS
	ret
setFont	endp



	; BX - Bytes Per Character
	; SI - Font offset
IF	SOFTLD
ldfont	proc	near
	call	isgraph
	jnc	$_1
	ret
$_1:	pushf
	cli
	mov	dx, 3C4h	; port 3C4h, EGA sequencr index
	mov	ax, 704h	;  al = 4, memory mode select
	out	dx, ax
	mov	dx, 3CEh	; port 3CEh, EGA graphic index
	mov	ax, 204h	;  al = 4, read map select
	out	dx, ax
	mov	ax, 5		;  al = 5, mode
	out	dx, ax
	mov	ax, 406h	;  al = 6, mode/chain/mem map
	out	dx, ax
	mov	dx, 3C4h
	mov	ax, 402h	;  al = 2, map mask register
	out	dx, ax

	mov	ax, 0A000h
	mov	es, ax

	mov	di, 0
	mov	si, offset fontbuf
	mov	cx, 256
$_l2:	push	cx
	mov	cx, bx
	cld
	rep	movsb
	add	di, 20h
	sub	di, bx
	pop	cx
	loop	$_l2

	mov	dx, 3C4h	; port 3C4h, EGA sequencr index
	mov	ax, 302h	;  al = 2, map mask register
	out	dx, ax
	mov	ax, 304h	;  al = 4, memory mode select
	out	dx, ax
	mov	dx, 3CEh	; port 3CEh, EGA graphic index
	mov	ax, 4		;  al = 4, read map select
	out	dx, ax
	mov	ax, 1005h	;  al = 5, mode
	out	dx, ax
	mov	ax, 0E06h	;  al = 6, mode/chain/mem map
	out	dx, ax
	mov	ax, bx
	dec	al
	mov	cl, 8
	shl	ax, cl
	or	ax, 9
	mov	dx, 3D4h	; port 3D4h, CGA/EGA reg index
	out	dx, ax		;  al = 9, max raster address

	popf		; Using PUSHF/CLI/POPF to retain interrupts flag
	ret
ldfont	endp


	; BX - Bytes Per Character
ELSE
ldfont	proc	near
	call	isgraph
	jnc	$_1
	ret
$_1:	push	bp
	mov	ax, 1100h
	xchg	bh, bl
	mov	cx, 0100h
	mov	dx, 0
	mov	bp, offset fontbuf
	push	cs
	pop	es
	pushf
	call	cs:old_10
	pop	bp
	ret
ldfont	endp
ENDIF


	;	Detect is current videomode graphic or text
	;	Carry Flag is clear - Text
	;	Carry Flag is set   - Graphic
isgraph	proc	near
	push	es
	push	dx
	push	ax

	mov	es, bios
	mov	al, byte ptr es:[49h]	; Current video mode
	cmp	al, 3
	jbe	$_t
	cmp	al, 7
	je	$_t
	cmp	al, 6
	jbe	$_g
	cmp	al, 0Dh
	jb	$_1
	cmp	al, 13h
	jbe	$_g

$_1:	pushf
	cli
	mov	dx, 3CEh
	in	al, dx		; Read index register
	mov	ah, al
	mov	al, 6
	out	dx, al		; Use register Graphic 6
	inc	dx
	in	al, dx		; Read this register
	xchg	al, ah
	dec	dx
	out	dx, al		; Restore index register
	popf
	test	ah, 1
	jnz	$_g

$_t:	clc
	jmp	short $_r
$_g:	stc
$_r:	pop	ax
	pop	dx
	pop	es
	ret
isgraph	endp



	;	Get one byte from XMS in AX
	;	SI - offset
getXMS	proc	near
	pushf		; Save direction flag
	push	bx
	mov	word ptr length, 2
	mov	word ptr xOffset, si
	mov	word ptr xDest, offset xbuf
	mov	si, offset memblk
	mov	ax, 0B00h
	call	dword ptr [XMS]
	mov	si, word ptr xOffset
	inc	si
	xor	ax, ax
	mov	al, byte ptr xbuf
	pop	bx
	popf
	ret
getXMS	endp



	;	Move XMS block down
	;	CX - count
	;	SI - offset
	;	DI - where to store
downXMS	proc	near
	pushf		; Save direction flag
	push	ax
	push	bx
	push	cx
	test	cx, 1
	jz	$_1
	inc	cx	; Length must be even
$_1:	mov	word ptr length, cx
	mov	word ptr xOffset, si
	mov	word ptr xDest, di
	mov	si, offset memblk
	mov	ax, 0B00h
	call	dword ptr [XMS]
	pop	cx
	mov	si, word ptr xOffset
	add	si, cx
	add	di, cx
	pop	bx
	pop	ax
	popf
	ret
downXMS	endp



XMS	dd	0
fonttab	dw	9 dup (0)
fontbuf	db	4096 dup (?)
xbuf	dw	0	; XMS exchange buffer
include	cyr.fnt

TSRend	label	byte
_TSR	ends



_TEXT	segment byte public 'CODE'
	assume	cs:_TEXT, ds:DGROUP
_isEGA	proc	near
	mov	ax, 1200h
	mov	bx, 10h
	int	10h
	cmp	bx, 10h
	jne	$_1
	xor	ax, ax
	ret
$_1:
	mov	ax, 1
	ret
_isEGA	endp



_isVGA	proc	near
	mov	ax, 1A00h
	mov	bx, 0
	int	10h
	cmp	bl, 7
	je	$_1
	cmp	bl, 8
	je	$_1
	xor	ax, ax
	ret
$_1:
	mov	ax, 1
	ret
_isVGA	endp



_isXMS	proc	near
	mov	ax, 4300h
	int	2Fh
	cmp	al, 80h
	je	$_1
	xor	ax, ax
	ret
$_1:
	mov	ax, 4310h
	int	2Fh
	mov	word ptr [_XMSControl], bx
	mov	word ptr [_XMSControl+2], es
	mov	ah, 00h
	call	dword ptr [_XMSControl]	; Get XMS Version Number
	ret
_isXMS	endp



_isGraph	proc	near
	mov	ax, 40h
	mov	es, ax
	mov	al, byte ptr es:[49h]	; Current video mode
	cmp	al, 3
	jbe	$_t
	cmp	al, 7
	je	$_t
	cmp	al, 6
	jbe	$_g
	cmp	al, 0Dh
	jb	$_1
	cmp	al, 13h
	jbe	$_g

$_1:	pushf
	cli
	mov	dx, 3CEh
	in	al, dx		; Read index register
	mov	ah, al
	mov	al, 6
	out	dx, al		; Use register Graphic 6
	inc	dx
	in	al, dx		; Read this register
	xchg	al, ah
	dec	dx
	out	dx, al		; Restore index register
	popf
	test	ah, 1
	jnz	$_g

$_t:	xor	ax, ax
	jmp	short $_r
$_g:	mov	ax, 1
$_r:	ret
_isGraph	endp



_installed	proc	near
	mov	ax, tsr_id
	mov	bx, 0
	int	2Fh		; Multiple resident manager
	cmp	bx, 0
	je	$_1
	mov	ax, bx
	mov	dx, es
	ret
$_1:	xor	ax, ax
	mov	dx, ax
	ret
_installed	endp



_sec4dos	proc	near
	mov	ax, 0D44Dh
	mov	bx, 0
	int	2Fh		; Multiple resident manager
	cmp	ax, 044DDh
	jne	$_1
	cmp	dl, 0
	je	$_1
	mov	ax, 1
	ret
$_1:	xor	ax, ax
	ret
_sec4dos	endp



_GetUMB	proc	near
	push	bp
	mov	bp, sp
	mov	ax, 5802h	; Get MemAlloc area
	int	21h
	mov	MemArea, al
	mov	ax, 5800h	; Get MemAlloc strategy
	int	21h
	mov	MemStrat, ax
	mov	ax, 5803h	; Set MemAlloc area: UMB
	mov	bx, 1
	int	21h
	jc	$_no
	mov	ax, 5801h	; Set MemAlloc strategy
	mov	bx, 41h
	int	21h
	mov	ax, [bp+4]
	dec	ax
	shr	ax, 4
	inc	ax
	mov	bx, ax
	mov	ax, 4800h
	int	21h
	jc	$_1
	mov	MemSeg, ax
$_1:	mov	ax, 5801h	; Restore MemAlloc strategy
	mov	bx, MemStrat
	int	21h
	mov	ax, 5803h
	mov	bh, 0
	mov	bl, MemArea
	int	21h
$_no:	mov	ax, MemSeg
	pop	bp
	ret
_GetUMB	endp



_stayTSR	proc	near
	push	bp
	mov	bp, sp
	mov	ax, _umb
	cmp	ax, 0
	jne	$_1
	mov	ax, __psp
	add	ax, 6		; Skip 60h bytes of PSP critical region
$_1:	mov	cs:dstseg, ax
	mov	cs:dssave, ds
	lds	dx, __Int0Vector
	mov	ax, 2500h
	int	21h		; Restore vector 0 to ds:dx

	mov	ax, seg _TSR
	mov	ds, ax
	assume	ds:_TSR
	mov	ax, 3509h
	int	21h		; DOS get vector 9 (keyboard) in es:bx
	mov	word ptr [old_9  ], bx
	mov	word ptr [old_9+2], es
	mov	ax, 3510h
	int	21h		; DOS get vector 10 (video) in es:bx
	mov	word ptr [old_10  ], bx
	mov	word ptr [old_10+2], es
	mov	ax, 352Fh
	int	21h		; DOS get vector 2F in es:bx
	mov	word ptr [old_2F  ], bx
	mov	word ptr [old_2F+2], es

	mov	tggl_f, offset toggle
	mov	es, cs:dstseg
	mov	word ptr [xDest+2], es
	mov	word ptr [versptr+2], es
	push	ds
	mov	ds, cs:dssave
	cmp	word ptr cs:_umb, 0
	pop	ds
	jne	$_2
	add	word ptr [versptr], 60h
	sub	word ptr [versptr+2], 6
$_2:	mov	si, offset origin
	mov	di, si
	mov	cx, [bp+4]
	sub	cx, offset origin
	cld
	rep	movsb

	push	es
	pop	ds
	mov	dx, offset int_9
	mov	ax, 2509h
	int	21h		; DOS set vector 9 to ds:dx
	mov	dx, offset int_10
	mov	ax, 2510h
	int	21h		; DOS set vector 10 to ds:dx
	mov	dx, offset int_2F
	mov	ax, 252Fh
	int	21h		; DOS set vector 2F to ds:dx

	mov	ds, cs:dssave
	assume	ds:DGROUP
	mov	es, __psp
	mov	es, es:[2Ch]	; Free DOS environment block
	mov	ah, 49h
	int	21h

	mov	ax, tsr_id
	mov	bh, 4		; BH=4 - Set CYR screen fonts
	int	2Fh

	cmp	_umb, 0
	jne	$_exit
	mov	dx, [bp+4]
	add	dx, 60h
	int	27h		; Terminate & stay resident

$_exit:	mov	ax, 4C00h
	int	21h

dstseg	dw	0
dssave	dw	0
_stayTSR	endp



_uninstall	proc	near
	push	ds

	mov	ax, tsr_id
	mov	bx, 0
	int	2Fh		; Multiple resident manager
	cmp	bx, 0
	mov	ax, 1
	je	$_r1
	mov	di, bx
	mov	cs:tsrmem, es
	mov	cs:tsrseg, es
	mov	ax, seg _TSR
	mov	ds, ax
	assume	ds:_TSR
	mov	si, offset version
	mov	ax, 2
$_1:	cmpsb
	jne	$_r
	cmp	byte ptr ds:[si], 0
	jne	$_1
	cmp	si, di
	je	$_1a
	add	cs:tsrseg, 6

$_1a:	mov	ax, 3509h
	int	21h		; DOS get vector 9 (keyboard) in es:bx
	mov	ax, es
	cmp	ax, cs:tsrseg
	jne	$_2
	cmp	bx, offset int_9
	jne	$_2
	mov	ax, 3510h
	int	21h		; DOS get vector 10 (video) in es:bx
	mov	ax, es
	cmp	ax, cs:tsrseg
	jne	$_2
	cmp	bx, offset int_10
	jne	$_2
	mov	ax, 352Fh
	int	21h		; DOS get vector 2F in es:bx
	mov	ax, es
	cmp	ax, cs:tsrseg
	jne	$_2
	cmp	bx, offset int_2F
	je	$_3

$_2:	mov	ax, 3
$_r1:	jmp	short $_r

$_3:	mov	es, cs:tsrseg
	assume	es:_TSR
	lds	dx, es:[old_9]
	mov	ax, 2509h
	int	21h		; DOS set vector 9 to ds:dx
	lds	dx, es:[old_10]
	mov	ax, 2510h
	int	21h		; DOS set vector 10 to ds:dx
	lds	dx, es:[old_2F]
	mov	ax, 252Fh
	int	21h		; DOS set vector 2F to ds:dx

	mov	es, cs:tsrmem
	mov	ah, 49h
	int	21h		; Free DOS environment block es:

	xor	ax, ax
$_r:	pop	ds
	ret

tsrmem	dw	0
tsrseg	dw	0
_uninstall	endp
_TEXT	ends



_DATA	segment word public 'DATA'
_tsr_id		dw	tsr_id
_version	label	dword
		dw	offset version, seg version
_flags		label	dword
		dw	offset flags, seg flags
_keysw		label	dword
		dw	offset keysw, seg keysw
_fontsw		label	dword
		dw	offset fontsw, seg fontsw
_fonttab	label	dword
		dw	offset fonttab, seg fonttab
_fontbuf	label	dword
		dw	offset fontbuf, seg fontbuf
_fontlist	label	dword
		dw	offset font8, seg font8
		dd	0
		dd	0
		dd	0
		dw	offset font12, seg font12
		dd	0
		dw	offset font14, seg font14
		dd	0
		dw	offset font16, seg font16
_handle		label	dword
		dw	offset handle, seg handle
_XMSTSR		label	dword
		dw	offset XMS, seg XMS
_lastbyte	dw	offset TSRend
_DATA	ends

_BSS	segment word public 'BSS'
_XMSControl	dd	?
MemArea		db	?
MemStrat	dw	?
MemSeg		dw	?
_umb		dw	?
_BSS	ends



	extrn	__psp: word
	extrn	__Int0Vector: dword
	public	_tsr_id
	public	_isEGA
	public	_isVGA
	public	_isXMS
	public	_isGraph
	public	_GetUMB
	public	_installed
	public	_sec4dos
	public	_stayTSR
	public	_uninstall
	public	_version
	public	_flags
	public	_keysw
	public	_fontsw
	public	_fonttab
	public	_fontbuf
	public	_fontlist
	public	_handle
	public	_lastbyte
	public	_XMSTSR
	public	_XMSControl
	public	_umb

	end
