
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <clib.h>
#include <c.h>

//#define DEBUG


#define MAXKEYS	2

extern uint    tsr_id;
extern ulong **XMSTSR;
extern ulong  *XMSControl;
extern char   *version;
extern uint   *fonttab;		// array of NEAR!!! pointers
extern uchar  *fontbuf;
extern uchar  *fontlist[9];
extern uint   *handle;		// XMS handle
extern uchar  *flags;		// TSR flags
extern uchar  *keysw;		// Two bytes key toggle combinations
extern uchar  *fontsw;		// Two bytes font toggle combinations
extern uint    lastbyte;	// This is offset!!!
extern uint    umb;
extern uint    _psp;

char far *installed (void);	// Installed version
int  isEGA     (void);
int  isVGA     (void);
int  isXMS     (void);
int  isGraph   (void);
uint GetUMB    (uint nbytes);
int  sec4dos   (void);
int  uninstall (void);
void stayTSR   (uint last);



    /********************************************************************/
    /* Internal variables.						*/
    /********************************************************************/
static char
    command = 0,		// Main option.
    adapter = 0;		// 'E' - EGA, 'V' - (S)VGA

static int
    transl  = 0,		// 'p' & 'H' translation: 1 on, -1 off
    noumb   = FALSE,		// Do not use UMB flag
    noxms   = FALSE,		// Do not use XMS flag
    noextra = FALSE,		// Do not cyrillize extra vmodes
    nowide  = FALSE,		// Do not load wide fonts
    size    = 0,		// Cell height
    keyset  = 0,		// Key switch combinations sat
    fontset = 0;		// Font switch combinations sat

static uint
    x, y;			// To avoid asm optimization problems

static uchar
    *segment;

static struct memblk {
  ulong   length;
  ushort  srcHandle;
  ulong   srcOffset;
  ushort  dstHandle;
  ulong   dstOffset;
} block;



    /********************************************************************/
    /* Messages.							*/
    /********************************************************************/
static char
    *notimpl = "cyr: %s: %c yet not implemented.\n",
    *illegal = "cyr: illegal %s: %c\n",
    *cmd     = "command",
    *opt     = "option",

    *cdinst  = "  Cyrillic driver %sinstalled.\n",
    *succde  = "successfully de",
    *isnot   = "is not ",
    *difvers = "of different version is ",
    *cantde  = "can not be de",
    *already = "already ",
    *cantbe  = "can not be ",

    *cantupd = "  Can not update settings:";

static char  heap[] =
  "  Usage: cyr <command> -[switches]\n";

static char  *mains[] = {
  "i     Install cyrillic driver",
  "",
  "u     Update driver parameters",
  "      You need not to reinstall driver if you want to change hot keys,\n"
  "      keymap or communication translation. These settings will be updated\n"
  "      in memory directly.\n",
  "d     Deinstall cyrillic driver",
  "",
  "k     install Keyboard driver only",
  "      This may help you if you want to use driver to enter pseudo graphic\n"
  "      symbols. In this case you need not to handle screen fonts.\n",
  "c     load Cyrillic fonts",
  "      Do not stay resident - load cyrillic font only.\n"
  "      If size of font is not specified use current video mode settings.\n"
  "      This may help you if you don't want to load driver but want to\n"
  "      read russian text.\n",
  "s     load System fonts",
  "      Do not stay resident - load system font only.\n"
  "      If size of font is not specified use current video mode settings.\n"
  "      This may help you if you want to restore screen fonts.\n",
  "h     print detailed Help",
  "",
};

static char  *adds[] = {
  "-e    force EGA detection",
  "",
  "-v    force VGA detection",
  "      If cyrillic driver misidentifies your video card (this may occure on\n"
  "      some older adapters), you may override the detected video adapter\n",
  "-u    do not use UMB",
  "      By default driver loads the resident portion of itself into UMB.\n"
  "      You may turn this capability off if you don't want it by some reason.\n"
  "      Do not use (!) DOS lh, loadhigh or QEMM loadhi commands because CYR\n"
  "      will do it better automatically: memory will not be fragmented.\n",
  "-x    do not use XMS",
  "      CYR uses XMS to store screen fonts that are not required for the\n"
  "      moment. If you need more XMS for some reason, you may turn off this\n"
  "      capability, screen fonts will be stored in main memory.\n",
  "-s<>  set font Size",
  "      You may get nonstandard screen size (30, 33 rows, etc.) if you load\n"
  "      font with nonstandard cell height (other than 8, 14, 16). This may\n"
  "      help you to fit larger portion of text in the screen without noticeable\n"
  "      loss of text quality. To set font size, specify cell height (8-16).\n"
  "      Examples:\n"
  "        cyr c -s16   ; Set cyrillic fonts of maximal size.\n"
  "        cyr s -s12   ; Set system fonts.\n",
  "-r<>  set RUS/LAT keyboard switch hot keys",
  "      You can specify up to two different hot keys combinations for switching\n"
  "      between Russian and Latin keyboard layout. You can assign any\n"
  "      combination of both left and right shift, control and alt keys. Left\n"
  "      and right keys are always treated as different keys and you must\n"
  "      explicitly specify what \"shift\" key do you use - left or right. To\n"
  "      assign a hotkey combination you must use the combination of symbols 'S'\n"
  "      'C', 'A', 's', 'c', 'a' that stands for left \"shift\", \"control\" and\n"
  "      \"alt\" and right \"shift\", \"control\" and \"alt\" respectively. So the case\n"
  "      of characters is important. By default the next combinations are used:\n"
  "      <rshift-lshift> and <rshift-rctrl>.\n"
  "      Example:\n"
  "        cyr i -rC -rsc\n",
  "-i<>  set IBM/CYR fonts switch hot keys",
  "      You can specify up to two different hot keys combinations for switching\n"
  "      between Cyrillic and IBM native screen fonts. You can assign any\n"
  "      combination of both left and right shift, control and alt keys. Left\n"
  "      and right keys are always treated as different keys and you must\n"
  "      explicitly specify what \"shift\" key do you use - left or right. To\n"
  "      assign a hotkey combination you must use the combination of symbols 'S'\n"
  "      'C', 'A', 's', 'c', 'a' that stands for left \"shift\", \"control\" and\n"
  "      \"alt\" and right \"shift\", \"control\" and \"alt\" respectively. So the case\n"
  "      of characters is important. By default the next combinations are used:\n"
  "      <lctrl-lalt> and <rctrl-ralt>.\n"
  "      Example:\n"
  "        cyr i -iAC -iac\n",
  "-n    do not cyrillize Nonstandard video modes",
  "      Cyrillic driver by default loads fonts of all sizes (8-16). This\n"
  "      allows to cyrillize nonstandard video modes used by some programs\n"
  "      (MultiEdit, TeleMate etc.) This however requires large amount of\n"
  "      memory. If you specify this option, only fonts of sizes 8, 14 and 16\n"
  "      will be loaded. That would be sufficient for most applications.\n",
  "-t    Translation of russian 'p', 'H' into latin 'p', 'H'",
  "      Some programs (Terminate, Netmail parsers, FOXPRO, NC, etc.) use\n"
  "      russian letters 'p' and 'H' as internal special codes, so they can\n"
  "      not pass correctly. This option allows you to translate this letters\n"
  "      into latin similarly looking letters.\n",
  "-t-   turn off Translation",
  "      If you need to prepare russian text in editor or word processor, you\n"
  "      must turn character translation off to get correct results. You need\n"
  "      not to reload cyrillic driver, just update driver options.\n",
};



    /********************************************************************/
    /* Additional functions.						*/
    /********************************************************************/
    /* Print exactly N characters.	*/
void printn (FILE *stream, char *s, short n) {
  short  i;

  for ( i=0; (s[i]!='\0') && (i<n); i++ )  fputc (s[i], stream);
  while ( i++<n )  fputc (' ', stream);
}



void usage (short fun) {
  short  i, pos=0;
  char *str;

  printf ("  EGA/VGA Cyrillic driver v%s (c) 1998-2000 Serge Goncharov.\n", version);
  if ( fun!=0 )  puts ("  Shareware version.");
  printf (heap);
  puts ("\n          Commands:");
  for ( i=0; i<sizeofa(mains)/2; i++ ) {
    str = mains[i<<1];
    if ( fun==0 ) {
      if ( strlen (str) > 40 ) {
	if ( pos==0 )  puts (str);
	else {
	  fputc ('\n', stdout);
	  puts (str);
	  pos = 0;
	}
      }
      else {
        if ( pos==0 ) {
          printn (stdout, str, 40);
	  pos = 1;
        }
        else {
          puts (str);
	  pos = 0;
        }
      }
    }
    else {
      puts (str);
      printf (mains[(i<<1)+1]);
    }
  }
  if ( pos!=0 ) {
    fputc ('\n', stdout);
    pos = 0;
  }
  puts ("\n          Switches:");
  for ( i=0; i<sizeofa(adds)/2; i++ ) {
    str = adds[i<<1];
    if ( fun==0 ) {
      if ( strlen (str) > 40 ) {
	if ( pos==0 )  puts (str);
	else {
	  fputc ('\n', stdout);
	  puts (str);
	  pos = 0;
	}
      }
      else {
        if ( pos==0 ) {
          printn (stdout, str, 40);
	  pos = 1;
        }
        else {
          puts (str);
	  pos = 0;
        }
      }
    }
    else {
      puts (str);
      printf (adds[(i<<1)+1]);
    }
  }
  if ( pos!=0 ) {
    fputc ('\n', stdout);
    pos = 0;
  }
  exit (0);
}



void detectVideo (void) {
  if ( !isEGA() ) {
    adapter = 0;
  }
  else if ( !isVGA() ) {
    adapter = 'E';
    nowide = TRUE;
  }
  else {
    adapter = 'V';
    nowide = FALSE;
  }
}



uchar *prepareFonts (void) {
  uchar  *ptr=fontlist[0], *font;
  int  i, j, size;

  for ( i=0; i<9; i++ ) {
    size = i+8;
    font = fontlist[i];
    if ( font==NULL || (noextra && !(i==0 || i==6 || i==8)) )  continue;
    fonttab[i] = (uint)ptr;
    for ( j=256*size; j>0; j-- )  *ptr++ = *font++;
    while ( *font != 0 ) {
      if ( nowide )  font += size+1;	// No wide system fonts
      else  for ( j=size+1; j>0; j-- )  *ptr++ = *font++;
    }
    *ptr++ = 0;
    font++;
    while ( *font != 0 ) {
      for ( j=size+1; j>0; j-- )  *ptr++ = *font++;
    }
    *ptr++ = 0;
    font++;
    if ( !nowide ) {
      while ( *font != 0 ) {
        for ( j=size+1; j>0; j-- )  *ptr++ = *font++;
      }
    }
    *ptr++ = 0;		// No wide cyrillic fonts
    if ( adapter=='E' && i>=8 )  return ptr;
  }
  return ptr;
}



    // str - symbolic string to analyze key combination
    // key - pointer to byte hotkey flag
    // returns 0 if error occured, number of symbols to skip if OK.
int setkey (char *str, uchar *key) {
  int  count;

  if ( str==NULL )  return 0;
  count=0;
  *key = 0;
  loop {
    switch ( *str++ ) {
    case 's':
      *key |= 1;
      ++count;
      break;
    case 'S':
      *key |= 2;
      ++count;
      break;
    case 'c':
      *key |= 16;
      ++count;
      break;
    case 'C':
      *key |= 32;
      ++count;
      break;
    case 'a':
      *key |= 4;
      ++count;
      break;
    case 'A':
      *key |= 8;
      ++count;
      break;
    default:
      return count;
    }
  }
}



void printhotkey (byte x) {
  int  flag=FALSE;
  if ( x&0x20 ) {
    flag = TRUE;
    printf ("<LCtrl>");
  }
  if ( x&0x10 ) {
    if ( flag )  fputc ('-', stdout);
    else  flag=TRUE;
    printf ("<RCtrl>");
  }
  if ( x&2 ) {
    if ( flag )  fputc ('-', stdout);
    else  flag=TRUE;
    printf ("<LShift>");
  }
  if ( x&1 ) {
    if ( flag )  fputc ('-', stdout);
    else  flag=TRUE;
    printf ("<RShift>");
  }
  if ( x&8 ) {
    if ( flag )  fputc ('-', stdout);
    else  flag=TRUE;
    printf ("<LAlt>");
  }
  if ( x&4 ) {
    if ( flag )  fputc ('-', stdout);
    printf ("<RAlt>");
  }
}



void printhotkeylist (char *type, byte *ptr) {
  int  i;

  printf ("  To toggle %s press ", type);
  for ( i=0; i<MAXKEYS && ptr[i]!=0; ++i ) {
    if ( i )  printf (" or ");
    printhotkey(ptr[i]);
  }
  printf (".\n");
}



    /********************************************************************/
    /* Command line maintainer.						*/
    /********************************************************************/
void main (int argc, char **argv, char **envp) {
  short  i, j, fsize, files=0, res;
  char *vers, *mess, **fnames;
  uchar *ptr, *font;
  uint  xmsvers;
  word  tmpw;

  segment = (uchar *)((ulong)fontlist[0]&0xFFFF0000ul);

  if ( argc==1 )  usage (0);
  fnames = (char **) malloc ((argc+1)*sizeof(char *));

  if ( !isswitch(argv[1][0]) ) {
    switch ( command=tolower(argv[1][0]) ) {
    case 'i':
    case 'd':
    case 'u':
    case 'c':
    case 's':
      break;
    case 'k':
      fprintf (stderr, notimpl, cmd, argv[1][0]);
      exit (2);
    case '?':
    case 'h':
      usage (1);
    default:
      fprintf (stderr, illegal, cmd, argv[1][0]);
      exit (2);
    }
    if ( argv[1][1]=='\0' )  argv[1][0]='\0';
    else  argv[1][0]='-';
  }

  i=1;				// Environment parsing.
  for ( j=0; envp[j]!=NULL; j++ )
    if ( strnicmp(envp[j],"local=",(size_t)3)==0 ) {
      argv[0] = &envp[j][9];
      i=0;
      break;
    }

  for ( ; i<argc; i++ ) {
    if ( isswitch(argv[i][0]) ) {
      j=1;
      while ( argv[i][j]!='\0' ) {
	switch ( tolower(argv[i][j]) ) {	// Options parsing.
	case 'e':
	  adapter = 'E';
	  nowide  = TRUE;
	  break;
	case 'v':
	  adapter = 'V';
	  nowide  = FALSE;
	  break;
	case 'u':
	  noumb = TRUE;
	  break;
	case 'x':
	  noxms = TRUE;
	  break;
	case 'n':
	  noextra = TRUE;
	  break;
	case 't':
	  switch ( argv[i][j+1] ) {
	  case '-':
	    transl = -1;
	    j++;
	    break;
	  default:
	    transl = 1;
	  }
	  break;
	case 's':
	  j++;
	  goto getsize;
	case '8':
	case '9':
	case '1':
getsize:  size = atoi (&argv[i][j]);
	  if ( !isdigit(argv[i][j]) )  size=0;
	  if ( size<8 || size>16 ) {
	    fprintf (stderr, "cyr: illegal font size: %d\n", size);
	    return;
	  }
	  while ( isdigit(argv[i][j+1]) )  j++;
	  break;
	case 'r':
	  if ( keyset>=MAXKEYS ) {
	    fprintf (stderr, "cyr: maximum key combinations already defined\n");
	    return;
	  }
	  res = setkey (&argv[i][j+1], keysw+keyset++);
	  if ( res==0 ) {
	    fprintf (stderr, "cyr: illegal key combination: %s\n", &argv[i][j+1]);
	    return;
	  }
	  j+=res;
	  break;
	case 'i':
	  if ( fontset>=MAXKEYS ) {
	    fprintf (stderr, "cyr: maximum key combinations already defined\n");
	    return;
	  }
	  res = setkey (&argv[i][j+1], fontsw+fontset++);
	  if ( res==0 ) {
	    fprintf (stderr, "cyr: illegal key combination: %s\n", &argv[i][j+1]);
	    return;
	  }
	  j+=res;
	  break;
        case '?':
        case 'h':
          usage (1);
        default:
          fprintf (stderr, illegal, opt, argv[i][j]);
	  return;
        }
	while ( isspace(argv[i][++j]) );
	j--;
	if ( isswitch(argv[i][++j]) )  j++;
      }
    }
    else if ( argv[i][0] == '\0' )  continue;
    else {
      fnames[files++] = argv[i];
      printf ("cyr: warning: filename parsing yet not implemented: %s\n", argv[i]);
    }
  }
  fnames[files] = NULL;
  if ( keyset )
    while ( keyset<MAXKEYS )  keysw[keyset++] = 0;
  if ( fontset )
    while ( fontset<MAXKEYS )  fontsw[fontset++] = 0;

# ifdef DEBUG
  ptr = (uchar *) 0xB0000000ul;
  for ( i=0; i<80*25; i++ ) {
    *ptr++ = 0;
    ptr++;
  }
# endif

  if ( (command=='s') || (command=='c') ) {
    noextra = FALSE;
    if ( adapter == 0 ) {
      detectVideo();
      if ( adapter == 0 ) {
	puts ("  Can not load fonts:");
        puts ("  No EGA/VGA adapter detected.");
	return;
      }
    }
    if ( *(uint far *)0x0040004Aul > 80 )  nowide=TRUE;
    if ( size==0 )  size = *(uint far *)0x00400085ul;	// BIOS cell height
    if ( size<8 || size>16 || fontlist[size-8]==NULL ) {
      fprintf (stderr, "  Font of size %d is unavailable.\n", size);
      return;
    }

    asm {
	mov	ax, tsr_id
	mov	bx, 0		// Test if CYR is installed
	int	2Fh
	mov	x, bx
    }
    if ( x!=0 ) {		// If CYR installed, we can change fonts
      if ( command=='s' ) {	// even in graphics
        asm {
	  mov	ax, tsr_id
	  mov	bh, 5		// BH=5 - Set IBM screen fonts
	  int	2Fh
        }
      }
      else {
        asm {
	  mov	ax, tsr_id
	  mov	bh, 4		// BH=5 - Set CYR screen fonts
	  int	2Fh
        }
      }
    }
    else if ( isGraph() ) {
      puts ("  Can not load fonts:");
      puts ("  Video adapter is in graphic mode.");
      return;
    }

    ptr = fontbuf;
    adapter = 'V';
    prepareFonts();
    font = segment+fonttab[size-8];
    for ( i=256*size; i>0; i-- )  *ptr++ = *font++;
    while ( *font != 0 ) {
      ptr = fontbuf + (*font++)*size;
      for ( i=0; i<size; i++ )  *ptr++ = *font++;
    }
    font++;
    if ( command=='c' ) {
      while ( *font != 0 ) {
	ptr = fontbuf + (*font++)*size;
	for ( i=0; i<size; i++ )  *ptr++ = *font++;
      }
      font++;
      while ( *font != 0 ) {
	ptr = fontbuf + (*font++)*size;
	for ( i=0; i<size; i++ )  *ptr++ = *font++;
      }
    }
    asm {
	push	bp
	mov	ax, 1110h
	mov	bl, 0
	mov	bh, byte ptr size
	mov	cx, 0100h
	mov	dx, 0
	les	bp, fontbuf
	int	10h
	pop	bp
    }
    return;
  }

  if ( command == 'd' ) {
    asm {			// BH=5 - Set IBM screen fonts
	mov	ax, tsr_id
	mov	bh, 5
	int	2Fh
    }
    asm {
	mov	ax, tsr_id
	mov	bx, 0		// Test if CYR is installed
	int	2Fh
	mov	x, bx
	mov	y, es
    }
    if ( x!=0 ) {
      xmsvers = isXMS();
      asm {
	mov	ax, tsr_id
	mov	bh, 1		// Get XMS handle
	int	2Fh
	mov	x, bx
      }
    }
    switch ( uninstall() ) {
    case 0:
      if ( x!=0 && xmsvers!=0 ) {
        asm {			// Free XMS
	  mov	ax, 0x0A00
	  mov	dx, x
	  call	dword ptr [XMSControl]
        }
      }
      mess = succde;
      break;
    case 1:
      mess = isnot;
      break;
    case 2:
      mess = difvers;
      break;
    case 3:
      mess = cantde;
      break;
    }
    printf (cdinst, mess);
    return;
  }

  vers = installed();
  if ( command==0 ) {
    if ( vers )  command = 'u';
    else  command = 'i';
  }

  if ( command=='i' ) {
    if ( vers != NULL ) {
      printf (cdinst, already);
      return;
    }
    if ( sec4dos() ) {
      printf (cdinst, cantbe);
      puts ("  Running under secondary 4DOS shell.");
      puts ("  Please exit NC, etc. and run it directly from command prompt.");
      return;
    }
    if ( adapter != 0 )
      printf ("  %cGA video adapter forced.\n", adapter);
    else {
      detectVideo();
      if ( adapter == 0 ) {
        printf (cdinst, cantbe);
        puts ("  No EGA/VGA adapter detected.");
	return;
      }
      else {
        printf ("  %cGA adapter detected.\n", adapter);
      }
    }
    if ( transl==1 )  *flags |= 0x10;

    ptr = prepareFonts();
    lastbyte = (uint)ptr;
	// Prepare XMS for TSR
    if ( !noxms && (xmsvers=isXMS())!=0 ) {
      printf ("  XMS v%x.%02x detected.\n", xmsvers>>8, xmsvers&0xFF);
      fsize = ptr-fontlist[0];
      fsize++;	// Need to store one extra byte because HIMEM operates
		// by words and we have to read last byte.
      if ( (fsize&1)!=0 )  fsize++;
      x = fsize>>10;
      if ( (fsize&1023) != 0 )  x++;
      asm {
	mov	ax, 0x0900
	mov	dx, x
	call	dword ptr [XMSControl]
	mov	x, ax
	mov	y, dx
      }
      if ( x==1 ) {
        *handle = y;
        block.length = fsize;
        block.srcHandle = 0;
        block.srcOffset = (ulong)fontlist[0];
        block.dstHandle = y;
        block.dstOffset = 0;
        asm {
	  mov	ax, 0x0B00
	  push	si
	  mov	si, offset block
	  call	dword ptr [XMSControl]
	  pop	si
	  mov	x, ax
        }
        if ( x!=1 ) {	// Error moving XMS block.
          asm {			// Free XMS
	    mov  ax, 0x0A00
	    mov  dx, y
	    call dword ptr [XMSControl]
          }
	  *handle = 0;
	  return;
        }
	else {
	  *XMSTSR = XMSControl;
	  lastbyte = (uint)fontlist[0];
	}
      }
    }
	// Allocate UMB
    if ( !noumb && (_psp<0xA000) )  umb = GetUMB(lastbyte);
    if ( umb ) {	// Copy MCB program name & make MCB self owned
      uchar  *ptr1 = (uchar *)((ulong)(_psp-1)<<16);
      ptr = (uchar *)((ulong)(umb-1)<<16);
      *(uint *)(ptr+1) = umb;
      for ( i=8; i<16; i++ ) {
	ptr[i] = ptr1[i];
      }
    }

    printf (cdinst, "");
    printhotkeylist ("RUS/LAT mode", keysw);
    printhotkeylist ("screen fonts", fontsw);
    stayTSR (lastbyte);
  }

  if ( command=='u' ) {
    if ( vers == NULL ) {
      puts (cantupd);
      printf (cdinst, isnot);
      return;
    }
    if ( strcmp (version, vers) != 0 ) {
      puts (cantupd);
      printf (cdinst, difvers);
      return;
    }
    if ( transl==1 ) {
      asm {
	mov	ax, tsr_id
	mov	bh, 6		// BH=6 - Turn translation on
	int	2Fh
      }
    }
    else if ( transl==-1 ) {
      asm {
	mov	ax, tsr_id
	mov	bh, 7		// BH=7 - Turn translation on
	int	2Fh
      }
    }
    if ( keyset ) {
      tmpw = *(word *)keysw;
      asm {
	mov	ax, tsr_id
	mov	bh, 8		// BH=8 - Set RUS/LAT hotkey combinations (CL, CH)
	mov	cx, tmpw
	int	2Fh
      }
    }
    if ( fontset ) {
      tmpw = *(word *)fontsw;
      asm {
	mov	ax, tsr_id
	mov	bh, 9		// BH=9 - Set font switch hotkey combinations (CL, CH)
	mov	cx, tmpw
	int	2Fh
      }
    }
    puts ("  Cyrillic driver settings updated.");
    if ( keyset )  printhotkeylist ("RUS/LAT mode", keysw);
    if ( fontset )  printhotkeylist ("screen fonts", fontsw);
  }
}
